﻿//Created: 9.11.16 by Longzhua
//Revision 1.0


using System;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.WoWInternals.WoWObjects;

#region [Method] - Class Redundancy
using HKM = PubFireMage.Core.Managers.HotkeyManager;
using R = PubFireMage.Rotation.Rotation;
using U = PubFireMage.Core.Unit;
#endregion

namespace PubFireMage
{
    public class PubFireMage : CombatRoutine
    {
        private static readonly Version version = new Version(1, 0, 0);
        public override string Name => "Public Fire Mage " + version;
        public override WoWClass Class => WoWClass.Mage;
        public override CapabilityFlags SupportedCapabilities => CapabilityFlags.All;
        private static LocalPlayer Me => StyxWoW.Me;

        #region [Method] - Implementations
        private Styx.TreeSharp.Composite _preCombatBehavior, _combatBuffBehavior, _combatBehavior;
        public override Styx.TreeSharp.Composite PreCombatBuffBehavior => _preCombatBehavior ?? (_preCombatBehavior = R.preCombatBuffing());
        public override Styx.TreeSharp.Composite CombatBuffBehavior => _combatBuffBehavior ?? (_combatBuffBehavior = R.combatBuffing());
        public override Styx.TreeSharp.Composite CombatBehavior => _combatBehavior ?? (_combatBehavior = R.rotationSelector());

        #region [Method] - Hidden Overrides
        public override void Initialize()
        {
            Logging.Write(Colors.OrangeRed, "Hello {0}!", Me.Name);
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "For optimal performance please use: Enyo");
            Logging.Write(Colors.White, "");
            Logging.Write(Colors.OrangeRed, "Current Version:");
            Logging.Write(Colors.OrangeRed, "-- Fire Mage v" + version + " --");
            Logging.Write(Colors.OrangeRed, "-- by Longzhua --");
            Logging.Write(Colors.OrangeRed, "-- A Fire Mage CoumbatRoutine --");
            HKM.registerHotKeys();
        }
        public override bool WantButton => true;
        public override void OnButtonPress() { Logging.Write(Colors.OrangeRed, "Coming soon!"); }
        public override void ShutDown() { HKM.removeHotkeys(); }
        #endregion

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
           // U.enemyAnnex(30);
        }
        #endregion

        #endregion
    }
}
