﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Styx.Common;

namespace PubFireMage.Core.Utilities
{
    class Log
    {

        #region Combat Log
        public static string lastCombatMSG;
        public static void combatLog(string Message, params object[] args)
        {
            if (Message == lastCombatMSG)
                return;
            Logging.Write(Colors.OrangeRed, "[Bacon] {0}", String.Format(Message, args));
            lastCombatMSG = Message;
        }
        #endregion

        #region Diagnostic Log
        public static void diagnosticLog(string Message, params object[] args)
        {
            if (Message == null)
                return;
            Logging.WriteDiagnostic(Colors.Firebrick, "{0}", String.Format(Message, args));
        }
        #endregion
    }
}
